/**
 * 
 */
package org.eclipse.linuxtools.tmf.trace;

import org.eclipse.linuxtools.tmf.event.TmfTimestamp;

/**
 * @author Thomas Gatterweh
 *
 */
public class TmfExperimentCheckpoint implements Comparable<TmfExperimentCheckpoint>
{

    // ========================================================================
    // Attributes
    // ========================================================================
    
	private final long index;
    private final TmfTimestamp timestamp;
    private final TmfTraceContext[] contexts;
    
    // ========================================================================
    // Constructors
    // ========================================================================

	/**
	 * @param timestamp
	 * @param contexts
	 */
	public TmfExperimentCheckpoint(long index, TmfTimestamp timestamp, TmfTraceContext[] contexts) {
		this.index = index;
		this.timestamp = timestamp;
		this.contexts = contexts;
	}

    // ========================================================================
    // Accessors
    // ========================================================================

    /**
	 * @return the fIndex
	 */
	public long getIndex()
	{
		return index;
	}

    /**
     * @return the checkpoint event timestamp
     */
    public TmfTimestamp getTimestamp() {
        return timestamp;
    }

	/**
     * @return the checkpoint event stream location
     */
    public TmfTraceContext[] getContexts() {
        return contexts;
    }

    // ========================================================================
    // Operators
    // ========================================================================

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	@Override
	public int compareTo(TmfExperimentCheckpoint other) {
        return timestamp.compareTo(other.timestamp, false);
	}

}
